import { CdkPortalOutlet } from '@angular/cdk/portal';
import { ComponentRef, Injector, StaticProvider } from '@angular/core';
import { ComponentRegistration } from './component-registration';
import { ComponentRegistry } from './component-registry';
export declare class PortalBuilder<TComponent = any, TIdentifier = string, TRegistration extends ComponentRegistration<TComponent, TIdentifier> = ComponentRegistration<TComponent, TIdentifier>> {
    private readonly registry?;
    private readonly identifier?;
    private readonly onPick?;
    private readonly injector?;
    constructor(registry?: ComponentRegistry<TComponent, TIdentifier, TRegistration> | undefined, identifier?: TIdentifier | undefined, onPick?: ((result: TRegistration) => void) | undefined, injector?: Injector | undefined);
    useRegistry(registrations: TRegistration[]): PortalBuilder<TComponent, TIdentifier, TRegistration>;
    useRegistry(registry: ComponentRegistry<TComponent, TIdentifier, TRegistration>): PortalBuilder<TComponent, TIdentifier, TRegistration>;
    /**
     * @alias useIdentifier
     */
    pick(identifier: TIdentifier): PortalBuilder<TComponent, TIdentifier, TRegistration>;
    useIdentifier(identifier: TIdentifier): PortalBuilder<TComponent, TIdentifier, TRegistration>;
    whenPicked(onPick: (result: TRegistration) => void): PortalBuilder<TComponent, TIdentifier, TRegistration>;
    useInjector(injector: Injector): PortalBuilder<TComponent, TIdentifier, TRegistration>;
    useInjector(providers: StaticProvider[], parent?: Injector, name?: string): PortalBuilder<TComponent, TIdentifier, TRegistration>;
    attachTo(outlet: CdkPortalOutlet): ComponentRef<TComponent>;
}
